/********************************************************
* ZeusCMD - OpenGL Tutorial 7 : Orthographic Projection *
* By Grant James (ZEUS)                                 *
* http://www.zeuscmd.com                                *
********************************************************/
#include <windows.h>
#include "glutil.h"

OpenGL *opengl;

bool init()
{
	glClearColor(0.93f, 0.93f, 0.93f, 0.0f);
	glColor3f(0.0f, 0.0f, 0.0f);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, opengl->getWidth(), opengl->getHeight());
	gluOrtho2D(0.0, 1.0, 0.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	return true;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);

	glBegin(GL_QUADS);
		glVertex3f(0.25f, 0.25f, 0.0f);
		glVertex3f(0.75f, 0.25f, 0.0f);
		glVertex3f(0.75f, 0.75f, 0.0f);
		glVertex3f(0.25f, 0.75f, 0.0f);
	glEnd();

	glFlush();
}

void idle()
{

}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	opengl = OpenGL::create();

	opengl->setInitFunc(init);
	opengl->setDisplayFunc(display);
	opengl->setIdleFunc(idle);

	if (!opengl->initGL("07 - Orthographic Projection", 500, 500, false, 32))
		return 1;

	opengl->runMessageLoop();

	return 0;
}
